#ifndef _VECTOR_H
#define _VECTOR_H

typedef struct vector vector_t;

struct vector
{
	void **items;
	int size;
	int capacity;
};

typedef struct vector_iterator vector_iterator_t;

struct vector_iterator
{
	vector_t *v;
	int nextidx;
};

vector_t *vector_create(int capacity);
void vector_destroy(vector_t *v);
void vector_ensure_capacity(vector_t *v, int newcapacity);
void vector_add(vector_t *v, void *item);
void vector_put(vector_t *v, int idx, void *item);
void *vector_get(vector_t *v, int idx);
int vector_size(vector_t *v);
void vector_sort(vector_t *v, int (*compar)(const void *, const void *));
void vector_delete(vector_t *v, int idx);
void vector_delete_shuffle(vector_t *v, int idx);
void vector_delete_find(vector_t *v, void *n);
int vector_is_member(vector_t *v, void *item);

vector_iterator_t *vector_iterator_create(vector_t *v);
void vector_iterator_destroy(vector_iterator_t *v);
void *vector_iterator_next(vector_iterator_t *v);

#endif
